'use strict';

function compile(node, ctx) {
    ctx.put(ctx.buildinFn('filter'));
    ctx.put('(');
    ctx.nodeOrCurrent(node.value);
    ctx.createScope(
        () => {
            ctx.put(',$=>');
            ctx.node(node.query);
        },
        (scopeStart, sp) => {
            ctx.put(')');
            return scopeStart + '(' + sp + ',';
        }
    );
    ctx.put(')');
}
function walk(node, ctx) {
    ctx.nodeOrNothing(node.value);
    ctx.node(node.query);
}
function stringify(node, ctx) {
    ctx.nodeOrNothing(node.value);
    ctx.put('.[');
    ctx.node(node.query);
    ctx.put(']');
}

exports.compile = compile;
exports.stringify = stringify;
exports.walk = walk;
