'use strict';

function compile(node, ctx) {
    ctx.createScope(
        () => {
            ctx.scope.arg1 = true;
            ctx.put('function($){return ');
            ctx.node(node.body);
            ctx.put('}');
        },
        (scopeStart, sp) => {
            return scopeStart + sp + ',';
        }
    );
}
function walk(node, ctx) {
    ctx.node(node.body);
}
function stringify(node, ctx) {
    if (node.legacy) {
        ctx.put('<');
        ctx.node(node.body);
        ctx.put('>');
    } else {
        ctx.put('=>');
        ctx.node(node.body);
    }
}

exports.compile = compile;
exports.stringify = stringify;
exports.walk = walk;
