'use strict';

function compile(node, ctx) {
    ctx.createScope(
        () => {
            ctx.put('($=>(');
            ctx.node(node.right);
            ctx.put('))');
        },
        (scopeStart, sp) => {
            return scopeStart + sp + ',';
        }
    );

    ctx.put('(');
    ctx.node(node.left);
    ctx.put(')');
}
function walk(node, ctx) {
    ctx.node(node.left);
    ctx.node(node.right);
}
function stringify(node, ctx) {
    ctx.node(node.left);
    ctx.put('|');
    ctx.node(node.right);
}

exports.compile = compile;
exports.stringify = stringify;
exports.walk = walk;
