'use strict';

const misc = require('./misc.cjs');

const self = value => value;

function toNumber(value) {
    return value !== null && typeof value === 'object'
        ? NaN
        : Number(value);
}

function processNumericArray(current, getter, apply) {
    if (misc.isArrayLike(current)) {
        if (typeof getter !== 'function') {
            getter = self;
        }

        for (const value of current) {
            const mappedValue = getter(value);

            if (mappedValue !== undefined) {
                apply(toNumber(mappedValue));
            }
        }
    }
}

exports.processNumericArray = processNumericArray;
exports.toNumber = toNumber;
